var myEventListener = function(event) {
    console.debug("myEventListener:" + event.type);
    if (event.type === "touchstart") {
        console.debug("myEventListener:pageX=" + event.changedTouches[0].pageX + ", pageY=" + event.changedTouches[0].pageY);
        console.debug("myEventListener:clientX=" + event.changedTouches[0].clientX + ", clientY=" + event.changedTouches[0].clientY);
        console.debug("myEventListener:screenX=" + event.changedTouches[0].screenX + ", screenY=" + event.changedTouches[0].screenY);
        //if (!android.selection.offset) {
            android.selection.offset = {x: event.changedTouches[0].screenX - event.changedTouches[0].clientX,
                       y: event.changedTouches[0].screenY - event.changedTouches[0].clientY};
            console.debug("offset x:" + android.selection.offset.x + ", y:" + android.selection.offset.y);
        //}
        android.selection.startTouch(event.changedTouches[0].screenX, event.changedTouches[0].screenY);
    }
    if (event.type === "selectstart" || event.type === "mousedown" || event.type === "mouseup" )
    {
        console.debug("preventDefault:" + event.type);
        event.preventDefault();
        event.stopPropagation();
    }
};

// Namespace
var android = {

};
android.selection = {};

android.selection.selectionStartRange = null;
android.selection.selectionEndRange = null;

/** The last point touched by the user. { 'x': xPoint, 'y': yPoint } */
android.selection.lastTouchPoint = null;
android.selection.offset = {x:0,y:0};
android.selection.doc = null;
android.selection.win = null;


/**
 * Starts the touch and saves the given x and y coordinates as last touch point
 */
    android.selection.startTouch = function(x, y) {
        console.debug("startTouch:x=" + x + ", y=" + y);
        android.selection.lastTouchPoint = {'x': x, 'y': y};
    };

    /**
     *  Checks to see if there is a selection.
     *
     *  @return boolean
     */
    android.selection.hasSelection = function() {
        return android.selection.doc && android.selection.doc.getSelection().toString().length > 0;
    };

    /**
     *  Clears the current selection.
     */
    android.selection.clearSelection = function() {
        //try {
            // if current selection clear it.
            if (android.selection.doc) {
                var sel = android.selection.doc.getSelection();
                sel.removeAllRanges();
                //android.selection.selectionStartRange = null;
                //android.selection.selectionEndRange = null;
            }
    //    }
    //    catch (e) {
    //        window.TextSelection.jsError(e);
    //    }
    };

    /**
     *  Handles the long touch action by selecting the last touched element.
     */
    android.selection.longTouch = function() {
        console.debug("longTouch:x=" + android.selection.lastTouchPoint.x + ", y=" + android.selection.lastTouchPoint.y);
        //try {
            android.selection.clearSelection();
            var doc = android.selection.doc;
            var sel = doc.getSelection();
            var offset = android.selection.offset;
            var range = doc.caretRangeFromPoint(android.selection.lastTouchPoint.x - offset.x,
             android.selection.lastTouchPoint.y - offset.y);
            range.expand("word");
            var text = range.toString();
            if (text.length == 1) {
                var baseKind = jpntext.kind(text);
                if (baseKind != jpntext.KIND['ascii']) {
                    try {
                        do {
                            range.setEnd(range.endContainer, range.endOffset + 1);
                            text = range.toString();
                            var kind = jpntext.kind(text);
                        } while (baseKind == kind);
                        range.setEnd(range.endContainer, range.endOffset - 1);
                    }
                    catch (e) {
                    }
                    try {
                        do {
                            range.setStart(range.startContainer, range.startOffset - 1);
                            text = range.toString();
                            var kind = jpntext.kind(text);
                        } while (baseKind == kind);
                        range.setStart(range.startContainer, range.startOffset + 1);
                    }
                    catch (e) {
                    }
                }
            }
            if (text.length > 0) {
                sel.removeAllRanges();
                sel.addRange(range);
                console.debug(range.toString());
                android.selection.saveSelectionRange();
                android.selection.selectionChanged(true);
            } else {
                console.debug("no select");
                sel.removeAllRanges();
            }
         //}
    //     catch (err) {
    //        window.TextSelection.jsError(err);
    //     }
    };

    /**
     * Tells the app to show the context menu.
     */
    android.selection.selectionChanged = function(isReallyChanged) {
    //    try {
            var sel = android.selection.doc.getSelection();
            if (!sel || sel.rangeCount <= 0) {
                return;
            }
            var range = sel.getRangeAt(0);
            var rects = range.getClientRects();
            var offset = {'x':0, 'y':0};//android.selection.offset;
            //var offset = android.selection.offset;
            var i;
            for (i = 0; i < rects.length; ++i) {
                var rect = rects[i];
                console.debug("rect: left=" + rect.left + ", right=" + rect.right + ", top=" + rect.top + ", bottom=" + rect.bottom);
            }
            var handleBounds = "[{'left': " + (rects[0].left + offset.x) + ", ";
                    handleBounds += "'top': " + (rects[0].top + offset.y) + ", ";
                    handleBounds += "'right': " + (rects[0].right + offset.x) + ", ";
                    handleBounds += "'bottom': " + (rects[0].bottom + offset.y) + "},";

                    handleBounds += "{'left': " + (rects[rects.length-1].left + offset.x) + ", ";
                    handleBounds += "'top': " + (rects[rects.length-1].top + offset.y) + ", ";
                    handleBounds += "'right': " + (rects[rects.length-1].right + offset.x) + ", ";
                    handleBounds += "'bottom': " + (rects[rects.length-1].bottom + offset.y) + "}]";
            var rangyRange = android.selection.getRange(sel);
            //console.debug(rangyRange);
            // Text to send to the selection

            var text = sel.toString();
            // Set the content width
            window.TextSelection.setContentWidth(android.selection.doc.body.clientWidth);
            // Tell the interface that the selection changed
            //sel.removeAllRanges();
            window.TextSelection.selectionChanged(rangyRange, text, handleBounds, isReallyChanged);

    //    }
    //    catch (e) {
    //        window.TextSelection.jsError(e);
    //    }
    };

    android.selection.getRange = function() {
        var serializedRangeSelected = rangy.serializeSelection();
        var serializerModule = rangy.modules.Serializer;
        if (serializedRangeSelected != '') {
            if (rangy.supported && serializerModule && serializerModule.supported) {
                var beginingCurly = serializedRangeSelected.indexOf("{");
                serializedRangeSelected = serializedRangeSelected.substring(0, beginingCurly);
                return serializedRangeSelected;
            }
        }
    }

    /**
     * Returns the last touch point as a readable string.
     */
    android.selection.lastTouchPointString = function(){
        if (android.selection.lastTouchPoint == null)
            return "undefined";
        return "{" + android.selection.lastTouchPoint.x + "," + android.selection.lastTouchPoint.y + "}";
    };

    android.selection.saveSelectionRange = function(){
        try {
            // Save the end point of the selection
            var doc = android.selection.doc;
            var sel = doc.getSelection();
            //var sel = window.getSelection();
            var range = sel.getRangeAt(0);
            var saveRange = doc.createRange();
            saveRange.setStart(range.endContainer, range.endOffset);
            this.selectionEndRange = saveRange;
            saveRange.setStart(range.startContainer, range.startOffset);
            this.selectionStartRange = saveRange;
        }
        catch (e) {
            window.TextSelection.jsError(e);
        }
    };

/**
 * Sets the last caret position for the start handle.
 */
    android.selection.setStartPos = function(x, y){
        var offset = android.selection.offset;
        var doc = android.selection.doc;
        android.selection.selectBetweenHandles(
            doc.caretRangeFromPoint(x - offset.x, y - offset.y),
            android.selection.selectionEndRange);
    };

/**
 * Sets the last caret position for the end handle.
 */
    android.selection.setEndPos = function(x, y){
        var offset = android.selection.offset;
        var doc = android.selection.doc;
        android.selection.selectBetweenHandles(android.selection.selectionStartRange,
                doc.caretRangeFromPoint(x - offset.x, y - offset.y));
    };

    android.selection.restoreStartEndPos = function() {
        //try {
            android.selection.selectBetweenHandles(android.selection.selectionEndRange, android.selection.selectionStartRange);
    //    }
    //    catch (e) {
    //        window.TextSelection.jsError(e);
    //    }
    };

/**
 *  Selects all content between the two handles
 */
    android.selection.selectBetweenHandles = function(startCaret, endCaret) {
        //try {
            console.debug("selectBetweenHandles:" + startCaret + "," + endCaret);
            if (startCaret && endCaret) {
                var rightOrder = startCaret.compareBoundaryPoints(Range.START_TO_END, endCaret) <= 0;
                if (rightOrder) {
                    android.selection.selectionStartRange = startCaret;
                    android.selection.selectionEndRange = endCaret;
                }
                else {
                    startCaret = android.selection.selectionStartRange;
                    endCaret = android.selection.selectionEndRange;
                }
                var doc = android.selection.doc;
                var range = doc.createRange();
                range.setStart(startCaret.startContainer, startCaret.startOffset);
                range.setEnd(endCaret.startContainer, endCaret.startOffset);
                android.selection.clearSelection();
                var selection = doc.getSelection();
                selection.removeAllRanges();
                selection.addRange(range);
                android.selection.selectionChanged(true);
            }
    //        else {
    //            android.selection.selectionStartRange = startCaret;
    //            android.selection.selectionEndRange = endCaret;
    //        }
    //    }
    //    catch (e) {
    //        window.TextSelection.jsError(e);
    //    }
    };
    var curContent = null;
    var curParaElement = null;
    var curParaCfi = null;
    var findstart = true;
    var includeFindElement = false;
    var disable_selection = false;
    function getNodeTextRecursion(element, level) {
        console.debug("getNodeTextRecursion:" + level + ", " + element.tagName);
        if (element.tagName && (element.tagName === "SCRIPT" ||element.tagName === "HEADER" ))
            return -1;
        if (element && element.style) {
            if (element.style.display === "none") {
                console.debug("getNodeTextRecursion:visible:false");
                return -1;
            }
        }
        if (element.nodeType === Node.TEXT_NODE) {
            console.debug("getNodeTextRecursion:TEXT_NODE," + element.textContent);
            if (!findstart && element.textContent.trim().length > 0 ) {
                curContent = element.textContent.trim();
                curParaElement = element;
                curParaCfi = getElementIndex(element);
                return 0;
            }
        }

        if (element.hasChildNodes()) {
            var nodelist = element.childNodes;
            //console.debug("getNodeTextRecursion:" + level + ", childNodes:" + nodelist.length);
            for (var i = 0; i < nodelist.length; ++i ) {
                if (findstart) {
                    if (nodelist[i].isSameNode(startParaElement)) {
                        console.debug("same element");
                        findstart = false;
                        if (includeFindElement) {
                            if (getNodeTextRecursion(nodelist[i], level+"-"+i) === 0)
                                return 0;
                        }
                    } else if (nodelist[i].hasChildNodes()) {
                        if (getNodeTextRecursion(nodelist[i], level+"-"+i) === 0)
                            return 0;
                    }
                } else {
                    if (getNodeTextRecursion(nodelist[i], level+"-"+i) === 0)
                        return 0;
                }
            }
        }
        return -1;
    }

    function getNodeText(element) {
        var node = null;
        if (!node) {
            node = getBodyElement();
        }
        if (node && getNodeTextRecursion(node, "0") === 0) {
            return 0;
        }
        console.debug("getNodeText:-1");
        return -1;
    }
    function getElementIndex(element) {
        if (!element)
            return "";
        if (element.tagName && element.tagName.toLowerCase() === "body")
            return "";
        var parentNode = element.parentNode;
        if (!parentNode)
            return "";
        var nodelist = parentNode.childNodes;
        var i = 0;
        for (i = 0; i < nodelist.length; ++i ) {
            if (nodelist[i].isSameNode(element)) {
                break;
            }
        }
        var s = getElementIndex(parentNode) + "/" + i;
        return s;
    }
    function getBodyElement() {
        console.debug("getBodyElement:");
        try {
            var doc = android.selection.doc;
            console.debug("getBodyElement:" + doc);
            if (doc) {
                var _$epubHtml = $("html", doc);
                var _$htmlBody = $("body", _$epubHtml);
                return _$htmlBody[0];
            }
        } catch(err) {
            console.warn(err);
        }
        return undefined;
    }
    function getElementByIndex(cfi) {
        try {
            var element = getBodyElement();
            //console.debug("getElementByIndex:" + element);
            if (element) {
                var node = element;
                var s = cfi.split("/");
                //console.debug("getElementByIndex:" + s + ", " + s.length);
                var i = 0;
                while(i < s.length) {
                    if (s[i].trim().length > 0 ) {
                        var childNodes = node.childNodes;
                        //console.debug("getElementByIndex:" + s[i] + "," + i + "," + childNodes.length);
                        if (!childNodes || childNodes.length <= parseInt(s[i].trim()))
                            return undefined;
                        node = childNodes[parseInt(s[i].trim())];
                    }
                    i++;
                }
                return node;
            }
        } catch(err) {
            console.warn(err);
        }
        return undefined;
    }
    function makeResult(result, text, cfi) {
        var obj = {result:result, text:text, cfi:cfi};
        return JSON.stringify(obj);
    }
    function scrollToView(element){
        var offset = element.offset().top;
        if(!element.is(":visible")) {
            element.css({"visibility":"hidden"}).show();
            var offset = element.offset().top;
            element.css({"visibility":"", "display":""});
        }
        var doc = android.selection.doc;
        var _$epubHtml = $("html", doc);
        var _$htmlBody = $("body", _$epubHtml);
        var win = android.selection.win;

        var visible_area_start = win.pageYOffset ;
        var visible_area_end = visible_area_start + document.documentElement.clientHeight;

        console.debug("scrollToView:" + offset + ","+visible_area_start + "," + visible_area_end);
        if(offset < visible_area_start || offset > visible_area_end){
             // Not in view so scroll to it
             //element[0].scrollTop = 0;
             win.scrollTo(0, offset);
             return false;
        }
        return true;
    }
    android.selection.setMarkPara = function (cfi) {
        console.debug("setMarkPara:" + cfi);
        try {
            disable_selection = true;
            markParaElement = getElementByIndex(cfi);
            android.selection.insureMarkParaVisibility();
            android.selection.markPara();
        } catch (err) {
            console.warn(err);
            markParaElement = undefined;
        }
    };
    android.selection.clearTTS = function() {
        disable_selection = false;
        android.selection.clearSelection();
    }
    android.selection.markPara = function() {
        if (!markParaElement)
            return;
        console.debug("markCurPara");
        var doc = android.selection.doc;
        var selection = doc.getSelection();
        var range = doc.createRange();
        range.setStart(markParaElement, 0);
        range.setEnd(markParaElement, markParaElement.textContent.length);
        selection.removeAllRanges();
        selection.addRange(range);
    };
    android.selection.insureMarkParaVisibility = function () {
        if (!markParaElement)
            return;
        var element = markParaElement;
        console.debug("insureCurParaVisibility:");
        try {
            if (element.nodeType != 1)
               element = element.parentNode;
            scrollToView($(element));
        } catch(err) {
            console.warn(err);
        }
    }
    android.selection.getFirstParagraph = function() {
        console.debug("getFirstParagraph:");
        findstart = false;
        var result = getNodeText(null);
        if (result === 0)
            return makeResult(result, curContent, curParaCfi);
        return makeResult(result, "", "");

    };
    android.selection.getNextParagraph = function() {
        console.debug("getNextParagraph:" + curParaElement);
        try {
            startParaElement = curParaElement;
            findstart = true;
            var result = getNodeText(startParaElement);
            if (result === 0)
                return makeResult(result, curContent, curParaCfi);
            return makeResult(result, "", "");
        } catch(err) {
            console.warn(err);
        }
        return makeResult(-1, "", "");
    };

android.selection.loadTemplate = function (name, params) {
    return android.selection.loadTemplate.cache[name];
};
/**
 *
 * @type {{fixed_book_frame: string, single_page_frame: string, scrolled_book_frame: string, reflowable_book_frame: string, reflowable_book_page_frame: string}}
 */
android.selection.loadTemplate.cache = {
    "scrolled_book_frame": '<div id="reflowable-book-frame" class="clearfix book-frame reflowable-book-frame"><div id="scrolled-content-frame"></div></div>',
    "reflowable_book_frame": '<div id="reflowable-book-frame" class="clearfix book-frame reflowable-book-frame"></div>',
    "reflowable_book_page_frame": '<div id="reflowable-content-frame" class="reflowable-content-frame"><iframe enable-annotation="enable-annotation" name="epubContentIframe"  id="epubContentIframe"></iframe></div>'
    /***
     * The `enable-annotation` attribute on an iframe helps detect the content frames for annotating tools such as Hypothesis
     * See here for more details:
     * https://h.readthedocs.io/projects/client/en/latest/publishers/embedding/
     * https://github.com/hypothesis/client/pull/533
     ***/
};

android.selection.loadframe = function(url) {
    console.debug("loadframe:" + url);
    var template = android.selection.loadTemplate("reflowable_book_frame", {});
    var _$el = $(template);
    var _$viewport = $("#viewport");
    _$viewport.append(_$el);
    var template1 = android.selection.loadTemplate("reflowable_book_page_frame", {});
    var $bookFrame = $(template1);
    $bookFrame = _$el.append($bookFrame);
    _$contentFrame = $("#reflowable-content-frame", $bookFrame);
    console.debug("loadframe:" + document.documentElement.clientWidth + "," + document.documentElement.clientHeight);
    _$viewport.css("width",  document.documentElement.clientWidth + "px");
    _$viewport.css("height",  document.documentElement.clientHeight + "px");
    _$contentFrame.css("width",  document.documentElement.clientWidth + "px");
    _$contentFrame.css("height",  document.documentElement.clientHeight + "px");
    _$iframe = $("#epubContentIframe", $bookFrame);
    _$iframe[0].setAttribute("src", url);
    _$iframe.css("left", "");
    _$iframe.css("right", "");
    _$iframe.css("width", "100%");
    _$iframe.css("height", "100%");
    _$iframe.css("position", "relative");
    //var doc = _$iframe[0].contentDocument;
    _$iframe[0].onload = function() {
//        var doc1 = _$iframe[0].contentDocument;
//        doc1.documentElement.addEventListener("touchstart", myEventListener, true);
//        doc1.documentElement.addEventListener("touchend", myEventListener, true);
//        doc1.documentElement.addEventListener("selectstart", myEventListener, true);
//        doc1.documentElement.addEventListener("mouseup", myEventListener, true);
//        doc1.documentElement.addEventListener("mousedown", myEventListener, true);
//        console.debug("document ready now" );
//        android.selection.doc = doc1;
    };
    $(function() {
      function manipIframe() {
        var el = $('p', $('iframe').contents());
        console.debug(el);
        if (!el || el.length < 1) {
          setTimeout(manipIframe, 100);
          return;
        }
        console.debug("frame document ready");
                var doc = _$iframe[0].contentDocument;
                var contentWindow = _$iframe[0].contentWindow;
                doc.addEventListener("touchstart", myEventListener, true);
                doc.addEventListener("touchend", myEventListener, true);
                doc.addEventListener("selectstart", myEventListener, true);
                doc.addEventListener("mouseup", myEventListener, true);
                doc.addEventListener("mousedown", myEventListener, true);
                console.debug("document ready now" );
                android.selection.doc = doc;
                android.selection.win = contentWindow;
                contentWindow.addEventListener("scroll", function () {
                                console.debug("scroll");
                                if (!disable_selection)
                                    android.selection.selectionChanged(true);
                            }, false);
      }
      manipIframe();
    });

};

$(document).ready(function () {
    console.debug("document ready");
    window.TextSelection.documentReady();
    document.documentElement.addEventListener("touchstart", myEventListener, true);
    document.documentElement.addEventListener("touchend", myEventListener, true);
    document.documentElement.addEventListener("selectstart", myEventListener, true);
    document.documentElement.addEventListener("mouseup", myEventListener, true);
    document.documentElement.addEventListener("mousedown", myEventListener, true);
});
